package perfilpeso;

/*
 * Cantoneira.java
 *
 * Created on 10 de Abril de 2005, 17:44
 */

/**
 *
 * @author jcbrc
 */
public class Cantoneira {
    
    private double largura1, largura2, espessura1, espessura2, raioFundo, raioPonta;
        
    /** Creates a new instance of Cantoneira */
    public Cantoneira() {
        
        largura1 = 0;
        largura2 = 0;
        espessura1 = 0;
        espessura2 = 0;
        raioFundo = 0;
        raioPonta = 0;
                        
    }
    
    public Cantoneira (double a1 , double a2 , double e1 , double e2 , double r1, double r2) {
    
        largura1 = a1;
        largura2 = a2;
        espessura1 = e1;
        espessura2 = e2;
        raioFundo = r1;
        raioPonta = r2;
        
    }   
    
     public Cantoneira (double a1 , double a2 , double e1 , double r1, double r2) {
    
        largura1 = a1;
        largura2 = a2;
        espessura1 = e1;
        espessura2 = e1;
        raioFundo = r1;
        raioPonta = r2;
        
    }   
    
      public Cantoneira (double a1 , double e1 , double r1, double r2) {
    
        largura1 = a1;
        largura2 = a1;
        espessura1 = e1;
        espessura2 = e1;
        raioFundo = r1;
        raioPonta = r2;
        
    }   
    
      public Cantoneira (double a1 , double e1 , double r1) {
    
        largura1 = a1;
        largura2 = a1;
        espessura1 = e1;
        espessura2 = e1;
        raioFundo = r1;
        raioPonta = 0;
        
    }   
      
      public Cantoneira (double a1 , double e1 ) {
    
        largura1 = a1;
        largura2 = a1;
        espessura1 = e1;
        espessura2 = e1;
        raioFundo = 0;
        raioPonta = 0;
        
    }   
     
           
      public double area () {
          
          double polinomio1 = espessura1 * espessura2;
          double polinomio2 = ( largura1 - espessura2 ) * espessura1;
          double polinomio3 = ( largura2 - espessura1 ) * espessura2;
          double polinomio4 = ( raioFundo * raioFundo ) * (1 - Math.PI / 4 );
          double polinomio5 = ( - raioPonta * raioPonta ) * (1 - Math.PI / 4 );
          
          return polinomio1 + polinomio2 + polinomio3 + polinomio4 + 2 * polinomio5;
      } 
      
      
       
       private double momento () {
           
           if (largura1 == largura2 && espessura1 == espessura2){
               
           double binomio1 =  Math.pow ( espessura1 , 3 ) / Math.sqrt(2);
           double polinomio1 = Math.sqrt(2) / 2 * ( largura1 + 2 * espessura1 ) / 2 * ( largura1 - espessura1 ) * espessura1;
           double polinomio2 = -Math.pow(raioFundo,3)*Math.sqrt(2)/4+(espessura1+raioFundo*Math.sqrt(2))*Math.pow(raioFundo,2)*(1-Math.PI/4);
           TrianguloRI tfundo = new TrianguloRI( raioFundo, -espessura1 * Math.sqrt(2)-raioFundo/Math.sqrt(2));
           Redondo setorFundo = new Redondo (2 * raioFundo, 3*Math.PI/4,Math.PI,(espessura1+raioFundo)*Math.sqrt(2));
           double testeFundo = (tfundo.centroide()*tfundo.area() - setorFundo.centroide()*setorFundo.area());
           double polinomio3 = Math.pow(raioPonta,3)*Math.sqrt(2)/4-(espessura1/2+largura1/2-raioPonta)*Math.sqrt(2)*Math.pow(raioPonta,2)*(1-Math.PI/4);
                          
           //return  binomio1 + 2 * polinomio1 + polinomio2 + 2 * polinomio3;
           return binomio1 + 2 * polinomio1 + testeFundo + 2 * polinomio3;
           
                   
           }
           else return 0;
                      
       }
       
        public double centroideDiagonal () {
                     
            return momento() / area();
          
        }
        
        public double centroideHorizontal() {
            
            return centroideDiagonal() / Math.sqrt(2);
            
        }
        
            
      public double momentoInerciaDiagonal(){
          
          if (largura1 == largura2 && espessura1 == espessura2){
              
          
            TrianguloRI tVertice = new TrianguloRI(2*espessura1,centroideDiagonal()-espessura1*Math.sqrt(2));
            double binomio1 = tVertice.momentoInercia();
          
            TrianguloRI tPonta = new TrianguloRI(espessura1,largura1/Math.sqrt(2)-centroideDiagonal());
            double binomio2 = tPonta.momentoInercia();
          
            double binomio3 = espessura1 * Math.sqrt(2) / 3;
            double polinomio1 = Math.pow((centroideDiagonal()-espessura1*Math.sqrt(2)),3);
            double polinomio2 = Math.pow((centroideDiagonal()-largura1/Math.sqrt(2)),3);
            double polinomio3 = binomio3 * ( polinomio1 - polinomio2 );
          
            double polinomio4 = espessura1 * Math.sqrt(2) + raioFundo / Math.sqrt(2);
            TrianguloRI tFundo = new TrianguloRI (raioFundo,centroideDiagonal()-polinomio4);
            double binomio4 = tFundo.momentoInercia();
          
            double polinomio5 = centroideDiagonal()-(espessura1+raioFundo)*Math.sqrt(2);
            Redondo doFundo = new Redondo (2*raioFundo,3*Math.PI/4,Math.PI,polinomio5);
            double binomio5 = doFundo.momentoDeInercia();
          
            double polinomio6 = (largura1+espessura1-raioPonta)/Math.sqrt(2)-centroideDiagonal();
            TrianguloRI tRaioPonta = new TrianguloRI(raioPonta,polinomio6);
            double binomio6 = tRaioPonta.momentoInercia();
          
            double polinomio7 = (largura1+espessura1)/Math.sqrt(2)-raioPonta*Math.sqrt(2)-centroideDiagonal();
            Redondo daPonta = new Redondo( 2 * raioPonta , 0 , Math.PI/4 , polinomio7 );
            double binomio7 = daPonta.momentoDeInercia();
          
          
            return binomio1 + 2 * binomio2 + 2 * polinomio3 + binomio4 - binomio5 - 2 * binomio6 + 2 * binomio7;
          
         }
          else
            return 0;
      }
      
      public double momentoInerciaHorizontal(){
          
          if (largura1 == largura2 && espessura1 == espessura2){
                                          
              double binomio1 = Math.pow( largura1 , 3 );
              double binomio2 = Math.pow( espessura1 , 3 );
              double binomio3 = centroideDiagonal()/Math.sqrt(2);
              double binomio4 = Math.pow( raioFundo , 4 );
              double binomio5 = Math.pow( raioFundo , 2 );
              double binomio6 = Math.pow( raioPonta , 4 );
              double binomio7 = Math.pow( raioPonta , 2 );
              
              Redondo doRaioFundo = new Redondo(2*raioFundo,0,Math.PI/2,binomio3-(raioFundo+espessura1));
              Redondo daPontaDeCima = new Redondo (2*raioPonta,0,Math.PI/2,largura1-raioPonta-binomio3);
              Redondo daPontaDeBaixo = new Redondo (2*raioPonta,Math.PI/2,Math.PI,binomio3-(espessura1-raioPonta));
                                          
              double polinomio1 = espessura1 * binomio1 / 12 + Math.pow((largura1/2-binomio3), 2)*largura1*espessura1;
              double polinomio2 = (largura1-espessura1)*binomio2/12+Math.pow((binomio3-espessura1/2),2)*(largura1-espessura1)*espessura1;
              double polinomio3 = binomio4 / 12 +Math.pow((binomio3-(raioFundo/2+espessura1)),2)*binomio5;
              double polinomio4 = - 0.5 * doRaioFundo.momentoDeInercia();
              double polinomio5 = - ( binomio6 / 12 + Math.pow((largura1-raioPonta/2-binomio3),2)*binomio7);
              double polinomio6 = 0.5 * daPontaDeCima.momentoDeInercia();
              double polinomio7 = - ( binomio6 / 12 + Math.pow((binomio3-(espessura1-raioPonta/2)),2)*binomio7);
              double polinomio8 = 0.5 * daPontaDeBaixo.momentoDeInercia();
              
              return polinomio1+polinomio2+polinomio3+polinomio4+polinomio5+polinomio6+polinomio7+polinomio8;
              
          }
          else
              return 0;
          
      }
      
      public double getLargura1(){
          
          return largura1;
      }
      
      public double getEspessura1(){
          
          return espessura1;
      }
      
      public double getRaioFundo(){
          
          return raioFundo;
      }
      
}      