package perfilpeso;

/*
 * Chato.java
 *
 * Created on 22 de Abril de 2005, 21:16
 */

/**
 *
 * @author jcbrc
 */
public class Chato {
    
    private double largura , espessura, raio;
    private double teta1; 
    private double teta2; 
    private double b ;
        
    /** Creates a new instance of Chato */
    public Chato() {
        
        largura = 0;
        espessura = 0;
        raio = 0;
        
    }
    
    public Chato(double l, double e){
        
        largura = l;
        espessura = e;
        raio = 0;
        
    }
    
    public Chato(double l, double e, double r){
        
        largura = l;
        espessura = e;
        raio = r;
    }
    
    public double area(){
                
        teta1 = Math.acos(espessura / ( 2 * raio));
        teta2 = Math.PI - teta1;
        b = raio * (1 - Math.sin(teta1));
        Redondo boleadoHorizontal = new Redondo ( 2 * raio , teta1 , teta2 , 0);
        double areaBoleada = boleadoHorizontal.area();
        double areaInterna = 2 * raio * Math.sin ( teta1 ) * espessura;
        
        
        if (raio >= espessura / 2 )
            return (largura - 2 * b) * espessura + areaBoleada - areaInterna;
        else
            return largura * espessura - raio * raio * ( 4 - Math.PI);
    }
     
    
    public double momentoInerciaHorizontal(){
        
        teta1 = Math.acos(espessura / ( 2 * raio));
        teta2 = Math.PI - teta1;
        b = raio * (1 - Math.sin(teta1));
        Redondo boleadoHorizontal = new Redondo ( 2 * raio , teta1 , teta2 , 0);
        Redondo raioPequeno = new Redondo ( 2  * raio, 0 , Math.PI / 2 , espessura / 2 - raio );
        
        double parteReta = (largura - 2 * b) * Math.pow (espessura,3) / 12;
        double parteBoleada = boleadoHorizontal.momentoDeInercia();
        double descontoDoBoleado = 2 * raio * Math.sin( teta1 ) * Math.pow( espessura , 3 ) / 12; 
        
        double parteCentral = ( largura - 2 * raio ) * Math.pow( espessura , 3 ) / 12;
        double parteRetaCanto = 2 * raio * Math.pow(( espessura - 2 * raio ) , 3 ) / 12;
        double parteBoleadaCanto = 2 * raioPequeno.momentoDeInercia();
        
        if ( raio >= espessura / 2 )
            return parteReta + parteBoleada - descontoDoBoleado;
        else
            return parteCentral + parteRetaCanto + parteBoleadaCanto;
    }
    
    public double momentoInerciaVertical(){
        
        teta1 = Math.acos(espessura / ( 2 * raio));
        b = raio * (1 - Math.sin(teta1));
        double parteReta = espessura * Math.pow ( largura - 2 * b , 3) / 12;
        Redondo boleadoVertical = new Redondo ( 2 * raio , 0 , Math.PI / 2 - teta1 , largura / 2 - raio);
        Redondo raioPequeno = new Redondo ( 2 * raio , 0 , Math.PI / 2 , largura / 2 - raio );
        double parteBoleada = boleadoVertical.momentoDeInercia();
        
        double parteReta2 = espessura * Math.pow(( largura - 2 * raio ) , 3 ) / 12;
        double parteCentral = ( espessura - 2 * raio ) * Math.pow( largura , 3 ) / 12;
        double descontoParteCentral = ( espessura - 2 * raio ) * Math.pow(( largura - 2 * raio ) , 3 ) / 12;
        double parteBoleadaCanto = 2 * raioPequeno.momentoDeInercia();
        
        if ( raio >= espessura / 2 )
            return parteReta + 2 * parteBoleada;
        else
            return parteReta2 + parteCentral - descontoParteCentral + parteBoleadaCanto;
    }
    
    public double getLargura(){
        
        return largura;
    }
    
    public double getEspessura(){
        
        return espessura;
    }
    
   public double getRaio(){
        
        return raio;
    }
}


