package perfilpeso;

/*
 * Quadrado.java
 *
 * Created on 20 de Abril de 2005, 20:20
 */

/**
 *
 * @author jcbrc
 */
public class Quadrado {
    
    private double lado, raio;
    
    /** Creates a new instance of Quadrado */
    public Quadrado() {
        
        lado = 0;
        raio = 0;
    }
    
    public Quadrado(double L) {
        
        lado = L;
        raio = 0;
    }
    
    public Quadrado(double L, double R) {
        
        lado = L;
        raio = R;
               
    }
    
    public double area() {
        
        return lado * lado - ( 4 - Math.PI) * raio * raio;
        
    }
    
    public double momentoInerciaHorizontal() {
        
        double binomio1 , binomio2 , binomio3 , binomio4;
        Redondo semicirculo = new Redondo( 2 * raio , 0 , Math.PI / 2 , lado / 2 - raio );
        
        binomio1 = Math.pow ( lado , 4 ) / 12;
        binomio2 = 2 * lado * Math.pow ( raio , 3 );
        binomio3 = raio * raio * lado * lado;
        binomio4 = 4 * Math.pow ( raio , 4 ) / 3;
        
        return binomio1 + binomio2 - binomio3 - binomio4 + 2 * semicirculo.momentoDeInercia();
        
    }
    
    public double momentoInerciaDiagonal() {
        
        double binomio1 = Math.pow ( lado , 4 ) / 12;
        double binomio2 = raio * raio * lado * lado / 2;
        double binomio3 = 2 * Math.pow ( raio , 3 ) * lado / 3;
        double binomio4 = 2 * Math.pow ( raio , 4 ) / 3;
        Redondo quadranteInferior = new Redondo ( 2 * raio , 0 , Math.PI / 4 , ( lado - 2 * raio )/ Math.sqrt(2));
        Redondo quadranteCentro = new Redondo ( 2 * raio , Math.PI / 4 , 3 * Math.PI / 4 , 0);
        
        double binomio5 = quadranteInferior.momentoDeInercia();
        double binomio6 = quadranteCentro.momentoDeInercia();
        
        return  2 * binomio5 + binomio1 - binomio2 + binomio3 - binomio4 + binomio6;
        
    }
    
    public double getLado(){
        
        return lado;
    }
    
    public double getRaio(){
        
        return raio;
    }
    
}
