package perfilpeso;

/*
 * Redondo.java
 *
 * Created on 18 de Abril de 2005, 20:33
 */

/**
 *
 * @author jcbrc
 */
public class Redondo {
    
    private double diametro, teta1, teta2, distCentro;
    
    /** Creates a new instance of Redondo */
    public Redondo() {
        
        diametro = 0;
        teta1 = 0;
        teta2 = Math.PI;
        distCentro = 0;
    }
    
    public Redondo ( double d) {
        
        diametro = d;
        teta1 = 0;
        teta2 = Math.PI;
        distCentro = 0;
    }
    
    public Redondo (double d, double alfa1, double alfa2, double a){
        
        diametro = d;
        teta1 = alfa1;
        teta2 = alfa2;
        distCentro = a; 
    }
    
    public double area(){
        
        double trig = -Math.sin(teta2) * Math.cos(teta2) + Math.sin(teta1) * Math.cos(teta1);
        return 0.25 * Math.pow(diametro, 2) * (( teta2 - teta1 ) - trig);
        
    }
    
    public double momento (){
        
        double trig1 = Math.sin(teta2) * Math.cos(teta2) - Math.sin(teta1) * Math.cos(teta1);
        double trig2 = ( Math.pow (( Math.sin (teta2)),3 ) - Math.pow( (Math.sin(teta1)),3)) / 3;
        return distCentro * Math.pow (diametro , 2) / 2 * (( teta2 - teta1 ) / 2 - trig1 / 2 ) + 0.25 * (Math.pow (diametro , 3)) * trig2;
        
    }
    
    public double centroide (){
        
        if (area() != 0)
            return this.momento() / this.area();
        else
            return 0;
    }
    
    public double momentoDeInercia(){
        
        double trig1 = Math.sin(teta2) * Math.cos(teta2) - Math.sin(teta1) * Math.cos(teta1);
        double trig2 = ( Math.pow ( Math.sin (teta2),3 ) - Math.pow( Math.sin(teta1),3)) / 3;
        double trig3 = ( teta2 - teta1 );
        double trig4 = Math.sin(teta2) * Math.pow ( Math.cos (teta2) , 3) - Math.sin(teta1) * Math.pow ( Math.cos (teta1) , 3);
        double binomio1 = 0.25 * distCentro * distCentro * diametro * diametro; 
        double binomio2 = 0.5 * distCentro * Math.pow ( diametro , 3 );
        double binomio3 = Math.pow (diametro , 4) / 8;
        
        return binomio1 * ( trig3 - trig1 ) + binomio2 * trig2 + binomio3 * ( trig3 / 8 + trig1 / 8 - trig4 / 4 );  
    }
    
    public double getDiametro(){
        
        return diametro;
        
    }
}

